#include "node.h"

template <class T>
void AppendNode(NODE<T> * pNode, NODE<T> **pHead, NODE<T> **pTail)
{
    if (*pHead == NULL) {
        *pHead = pNode;
        pNode->pPrev = NULL;
    }
    else {                
        (*pTail)->pNext = pNode;  
        pNode->pPrev = *pTail;
    }
    *pTail = pNode;       
    pNode->pNext = NULL;  
}

// Inserts a node into the list after pAfter
template <class T>
void InsertNode(NODE<T> *pNode, NODE<T> *pAfter, NODE<T> **pTail)
{
	pNode->pNext = pAfter->pNext; 
	pNode->pPrev = pAfter;           

	if (pAfter->pNext != NULL)       
		pAfter->pNext->pPrev = pNode;
	else
		*pTail = pNode;      

	pAfter->pNext = pNode;   
}

template <class T>
void InsertNodeAt(NODE<T> *pNode, NODE<T> *pAt, NODE<T> **pHead)
{
	pNode->pNext = pAt;
	pNode->pPrev = pAt->pPrev;


	if (pAt->pPrev == NULL) //head
		*pHead = pNode;
	else
		pAt->pPrev->pNext = pNode; 
		
	pAt->pPrev = pNode;
}

// Removes the specified node from the list
template <class T>
void RemoveNode(NODE<T> *pNode, NODE<T> **pHead, NODE<T> **pTail)
{
	if (pNode->pPrev == NULL)  
		*pHead = pNode->pNext;

	else
		pNode->pPrev->pNext = pNode->pNext;  

	if (pNode->pNext == NULL)  
		*pTail = pNode->pPrev;
   
	else
		pNode->pNext->pPrev = pNode->pPrev;

	delete pNode;  
}

// Deletes the entire list
template <class T>
void DeleteAllNodes(NODE<T> **pHead, NODE<T> **pTail)
{
	while (*pHead != NULL)   
		RemoveNode(*pHead, pHead, pTail);
}

